/*
#NAME
#  Finfo - distributed file status
#
#SYNOPSIS
#  Finfo [option].. [file|URL]..
#
#DESCRIPTION
#
#OPTIONS
#
#SEE ALSO
#
#BUGS
#
#AUTHOR
#  John Chambers <jc@trillian.mit.edu>
*/

#include "D.h"
#include "sys_types.h"
#include "sys_stat.h"

char  buf[BUFSIZ];
long  bufsiz = BUFSIZ;
long  buflen = 0;
long  bytecount = 0;
int   filecount = 0;
STat  st = {0};

main(ac,av)
	int   ac;
	char**av;
{	int   a, f;

:1	ac = Dinit(ac,av);

	for (a=1; a<ac; a++) {
		switch (av[a][0]) {
		case '+':
		case '-':
:1			V1 "Unknown option \"%s\" ignored.",av[a] V;
			continue;
		default:
			++filecount;
			Bzero(&st,sizeof(st));
			if ((f = Stat(av[a],&st)) < 0) {
				exitstat = errno;
:2				V2 "File %d is \"%s\"",f,av[a] V;
				continue;
			}
			printf("%s:\n",av[a]);
			printf("\tst_mode:  %10X=%10o.\n",U(st.st_mode),U(st.st_mode));
			printf("\tst_ino:   %10X=%10u.\n",U(st.st_ino),U(st.st_ino));
			printf("\tst_dev:   %10X=%10u.\n",U(st.st_dev),U(st.st_dev));
			printf("\tst_rdev:  %10X=%10u.\n",U(st.st_rdev),U(st.st_rdev));
			printf("\tst_nlink: %10X=%10u.\n",U(st.st_nlink),U(st.st_nlink));
			printf("\tst_uid:   %10X=%10u.\n",U(st.st_uid),U(st.st_uid));
			printf("\tst_gid:   %10X=%10u.\n",U(st.st_gid),U(st.st_gid));
			printf("\tst_size:  %10X=%10u.\n",U(st.st_size),U(st.st_size));
			printf("\tst_atime: %10X=%10u.\n",U(st.st_atime),U(st.st_atime));
			printf("\tst_mtime: %10X=%10u.\n",U(st.st_mtime),U(st.st_mtime));
			printf("\tst_ctime: %10X=%10u.\n",U(st.st_ctime),U(st.st_ctime));

			Close(f);
		}
	}
	if (filecount < 1) {
		while ((buflen = Read(0,buf,bufsiz)) > 0) {
:5			V5 "Got %s",Dspp(buf) V;
			Write(0,buf,buflen);
			bytecount += buflen;
		}
		if (buflen < 0) {
			exitstat = errno;
:1			V1 "Can't read stdin file %d \"%s\" [Err %d=%s=%s]",0,av[a],Errinfo V;
		}
	}
:2	V2 "%10d files copied.",filecount V;
:2	V2 "%10d bytes copied.",bytecount V;

:2	V2 "Exit status %d.",exitstat V;
	Exit(exitstat);
}
