:i	static char d_open_sccs_id[] = "%W% %G%";
:1#include "D_s.h"
#include <fcntl.h>

static Str srvr={0};
static Str file={0};

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* CALL:
*   daOpen(name,flags,mode)
*   	char *name;
*   	int   flags;
*   	int   mode;
*
* DESCRIPTION:
*
* Distributed-Access file-open routine.  We pass the  name  to  daPrsPath  to
* split it into a server and file name. We try to contact the server. If that
* succeeds, we send a message to the server asking it to open  the  file  for
* us. If it agrees, we note the fact in our table, and return our file handle
* to the caller.
*
* AUTHOR: John Chambers.
*
* CHANGES:
*/
FCT	d_open(name,flags,mode)
	char *name;
	int   flags;
	int   mode;
{	int   v = -1;
	int   e = ENOENT;
	int   fd;
	File* fp;
	Srvr* sp;
	char  onum[16];
static Str srvr = {0};
static Str file = {0};
:f	Fenter("d_open");
:5	V5s "Called for %s flags=0x%X mode=0%o.",Dspp(name),flags,mode V;
	if (Vlvl > 6) DmpFiles("d_open entry");
	if (!(fp = d_fileslot(name))) {
:d		V1 "Can't allocate new file slot." V;
		Fail;
	}
	fp->flgs |= File_OPEN;
	if (Vlvl > 4) DmpFiles("d_open after d_fileslot");
	v = open(name,flags,mode);
:6	V6s "open(\"%s\",%08lX,0%o)=%d [Err %d=%s=%s]",name,flags,mode,v,Errinfo V;
	if (v >= 0) {
:5		V5 "Local file %d=%s",v,Dspp(name) V;
		fp->fh = fp->lfd = v;
		Done;
	}
	if (!daPrsPath(name,&srvr,&file)) {
		e = errno;
:5		V5s "No server name in %s",Dspp(name) V;
		Fail;
	}
	if (!(sp = daSrvrLink(&srvr))) {
		e = errno;
:5		V5s "Can't contact server %s [Err %d=%s=%s]",DspSV(srvr),Errinfo V;
		Fail;
	}
:5	V5s "Srvr %08X is %s",sp,DspSV(sp->name) V;
/*
* Build request to open the file.
*/
	SrvrReq.l = 0;
	AppStrF(&SrvrReq,">OPEN ",6);
	if (flags) {
		if      ((flags & 3) == O_RDWR)   {AppStrF(&SrvrReq,"F:RW",4);}
		else if ((flags & 3) == O_WRONLY) {AppStrF(&SrvrReq,"F:W" ,3);}
		else                              {AppStrF(&SrvrReq,"F:R" ,3);}
:5		V7s "SrvrReq=%s [fl...]",DspSV(SrvrReq) V;
		if (flags & O_APPEND)   {AppStrF(&SrvrReq,"+A",2);}
		if (flags & O_NONBLOCK) {AppStrF(&SrvrReq,"+NB",3);}
		if (flags & O_CREAT)    {AppStrF(&SrvrReq,"+C",2);}
		if (flags & O_TRUNC)    {AppStrF(&SrvrReq,"+T",2);}
		if (flags & O_EXCL)     {AppStrF(&SrvrReq,"+X",2);}
		AppStrF(&SrvrReq," ",1);
	}
:5	V7s "SrvrReq=%s [flags]",DspSV(SrvrReq) V;
	if (mode) {
		sprintf(onum,"%o \0",mode);
		AppStrF(&SrvrReq,"M:0",3);
		AppStrF(&SrvrReq,onum,-1);
	}
:5	V7s "SrvrReq=%s [mode]",DspSV(SrvrReq) V;
	AppStrF(&SrvrReq,file.v,file.l);
	AppStrF(&SrvrReq,"\n",1);
:5	V5s "SrvrReq=%s [final]",DspSV(SrvrReq) V;
	if (daReqRpl(sp,&SrvrReq,&Null,&SrvrRpl,"<OPEN ") < 0) {
:5		V1 "No reply to %s",DspSV(SrvrReq) V;
		Fail;
	}
:5	V5s "SrvrRpl=%s",DspSV(SrvrRpl) V;
	if (Streqn(SrvrRpl.v,"<OPEN ",6)) {
		sscanf(SrvrRpl.v+6,"%d",&fd);
:5		V5s "Got remote file number %d.",fd V;
		if (fd < 0) {
:2			V2 "Failed to open %s on server %s [Err %s",DspSV(file),DspSV(sp->name),DspSV(SrvrRpl) V;
			Fail;
		}
		fp->rfd = fd;
		fp->lfd = sp->sock;
		fp->srvr = sp;
		fp->flgs |= File_OPEN;
:3	} else {
:3		V3 "Bad reply to %s (%s)",DspSV(SrvrReq),DspSV(SrvrRpl) V;
	}
	if (Vlvl > 2) {if (Vlvl > 4) {DmpFiles("d_open");} else {DmpFile(fp);}}
done:
	v = fp->fh;
:f	Fexit;
	return v;
fail:
	fp->flgs = 0;	/* File isn't open */
:f	Fexit;
	errno = e;
	return -1;
}

#if 0
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* This is a debug wrapper around the Unix open() system call.  Note that D.h
* defines  several  Open*()  macros for calling d_open(), mostly because the C
* preprocessor can't handle macros with variable numbers of parameters.
*
* If  your system has the syscall() routine and the SYS_* symbols are defined,
* then we will use them to do the system  call,  and  define  our  own  open()
* routine,  allowing  the  debug  package  to  intercept  calls of open(f) and
* generate debug output.
*/

d_open(name,flags,mode)
	char *name;
{	int   v;
	int   e;
:8	V8s "open(\"%s\",%08lX,0%o)",name,flags,mode V;
	errno = 0;
	v = open(name,flags,mode);
	e = errno;
:6	V6s "open(\"%s\",%08lX,0%o)=%d [Err %d=%s=%s]",name,flags,mode,v,Errinfo V;
	if (v >= 0) {
		d_newfile(File_LOCAL,v,name,"open");
	}
	errno = e;
	return v;
}
#endif
