:i	static char d_stat_sccs_id[] = "%W% %G%";
:1#include "D_s.h"
#include "sys_stat.h"
#include "srvr.h"

static struct {
	char* name;
	int   size;
	int   base;
} flds[] = {
	{"mode",	4,	8},
	{"ino",		3,	10},
	{"dev",		3,	10},
	{"rdev",	4,	10},
	{"nlink",	5,	10},
	{"uid",		3,	10},
	{"gid",		3,	10},
	{"size",	4,	10},
	{"atime",	5,	10},
	{"mtime",	5,	10},
	{"ctime",	5,	10},
	{0,0,0}
};

/*
* Debug wrapper for the Unix/Posic stat() routine.
*/
d_stat(name,s)
	char*name;
	STat*s;
{	int   v;
	int   e=errno;
	int   c, i;
	Str   srvr;
	Str   file;
	Srvr* sp=0;
:f	Fenter("d_stat");
:8	V8s "stat(%08X=\"%s\",%08lX)",name,name,s V;
	errno = 0;
	v = stat(name,s);
	if (v == 0) {
:5		V5s "stat(\"%s\",%08lX)=%d [Err %d=%s=%s] at %s.",name,s,v,Errinfo,Vtimh V;
		return v;
	}
:5	V5 "It's not a local file; is it remote?" V;
	if (!daPrsPath(name,&srvr,&file)) {
		e = errno;
:5		V5s "No server name in %s",Dspp(name) V;
		Fail;
	}
	if (!(sp = daSrvrLink(&srvr))) {
		e = errno;
:5		V5s "Can't contact server %s [Err %d=%s=%s]",DspSV(srvr),Errinfo V;
		Fail;
	}
:5	V5s "Srvr %08X is %s",sp,DspSV(sp->name) V;
/*
* Build request to stat the file.
*/
	SrvrReq.l = 0;
	AppStrF(&SrvrReq,">STAT ",6);
	AppStrF(&SrvrReq,file.v,file.l);
	AppStrF(&SrvrReq,"\n",1);
:5	V5s "SrvrReq=%s [final]",DspSV(SrvrReq) V;
	if (daReqRpl(sp,&SrvrReq,&Null,&SrvrRpl,"<STAT ") < 0) {
:5		V1 "No reply to %s",DspSV(SrvrReq) V;
		Fail;
	}
:5	V5s "SrvrRpl=%s",DspSV(SrvrRpl) V;
	SrvrRpl.p = SrvrRpl.v + 5;
	while ((c = *SrvrRpl.p) && (c != '\n')) {
:5		V5 "Left: c=%02X='%c' %s",B8(c),Dsp(c),Dspp(SrvrRpl.p) V;
:7		ChkStrM(&SrvrRpl,"SrvrRpl");
		if (c == ' ') {
			SrvrRpl.p++;
			continue;
		} else if (Streqn(SrvrRpl.p,"mode=",5)) {
			SrvrRpl.p += 5; s->st_mode = SkipInt(&SrvrRpl,8);
		} else if (Streqn(SrvrRpl.p,"ino=",4)) {
			SrvrRpl.p += 4; s->st_ino = SkipInt(&SrvrRpl,10);
		} else if (Streqn(SrvrRpl.p,"dev=",4)) {
			SrvrRpl.p += 4; s->st_dev = SkipInt(&SrvrRpl,10);
		} else if (Streqn(SrvrRpl.p,"uid=",4)) {
			SrvrRpl.p += 4; s->st_uid = SkipInt(&SrvrRpl,10);
		} else if (Streqn(SrvrRpl.p,"gid=",4)) {
			SrvrRpl.p += 4; s->st_gid = SkipInt(&SrvrRpl,10);
		} else if (Streqn(SrvrRpl.p,"rdev=",5)) {
			SrvrRpl.p += 5; s->st_rdev = SkipInt(&SrvrRpl,10);
		} else if (Streqn(SrvrRpl.p,"size=",5)) {
			SrvrRpl.p += 5; s->st_size = SkipInt(&SrvrRpl,10);
		} else if (Streqn(SrvrRpl.p,"nlink=",6)) {
			SrvrRpl.p += 6; s->st_nlink = SkipInt(&SrvrRpl,10);
		} else if (Streqn(SrvrRpl.p,"atime=",6)) {
			SrvrRpl.p += 6; s->st_atime = SkipInt(&SrvrRpl,10);
		} else if (Streqn(SrvrRpl.p,"mtime=",6)) {
			SrvrRpl.p += 6; s->st_mtime = SkipInt(&SrvrRpl,10);
		} else if (Streqn(SrvrRpl.p,"ctime=",6)) {
			SrvrRpl.p += 6; s->st_ctime = SkipInt(&SrvrRpl,10);
		} else if (c == '\n') {
:5			V5 "End of response." V;
			break;
		} else {
:2			V2 "%s not recognized.",Dspp(SrvrRpl.p) V;
			SrvrRpl.p++;
			continue;
		}
	}
:5	V5 "Left: c=%02X='%c' %s [END]",B8(c),Dsp(c),Dspp(SrvrRpl.p) V;
done:
:f	Fexit;
	return 0;
fail:
:f	Fexit;
	errno = e;
	return -1;
}

int
SkipInt(sp,base)
	Str* sp;
	int  base;
{	int  r=0;
	int  c;
:f	Fenter("SkipInt");
	while ((c = *sp->p) && ('0' <= c) && (c < '0'+base)) {
:8		V8 "c=%02X='%c' r=%d.",B8(c),Dsp(c),r V;
		r = (r * base) + (c - '0');
		sp->p ++;
	}
:7	V7 "c=%02X='%c' r=%d final value.",B8(c),Dsp(c),r V;
:f	Fexit;
	return r;
}

/*
* Debug wrapper for the Unix/Posic  lstat()  routine.   This  is  like
* stat(),  but  for  symbolic  links,  returns  the status of the link
* rather than the file that it points to.  Note that we trust  someone
* to  tell  us  vie  the symbol HAS_lstat whether lstat exists on this
* system.
*/
d_lstat(f,s)
	char*f;
	STat*s;
{	int   v;
:8	V8s "lstat(%08X=\"%s\",%08lX)",f,f,s V;
	errno = 0;
#if defined(HAS_lstat) && (HAS_lstat > 0)
	v = lstat(f,s);
#else
:6	V6s "This system doesn't have lstat(), using stat()" V;
	v = d_stat(f,s);
#endif
:5	V5s "lstat(\"%s\",%08lX)=%d [Err %d=%s=%s] at %s.",f,s,v,Errinfo,Vtimh V;
:9	H5(s,sizeof(STat),"STat");
	return v;
}

