#include "err.h"

ERRTBL sys_errtbl[] = {
	{   0,	"OK",	"No problem" },
	{   1,	"EPERM",	"Operation not permitted " },
	{   2,	"ENOENT",	"No such file or directory " },
	{   3,	"ESRCH",	"No such process " },
	{   4,	"EINTR",	"Interrupted system call " },
	{   5,	"EIO",	"I/O error " },
	{   6,	"ENXIO",	"No such device or address " },
	{   7,	"E2BIG",	"Arg list too long " },
	{   8,	"ENOEXEC",	"Exec format error " },
	{   9,	"EBADF",	"Bad file number " },
	{  10,	"ECHILD",	"No child processes " },
	{  11,	"EAGAIN",	"Try again " },
	{  12,	"ENOMEM",	"Out of memory " },
	{  13,	"EACCES",	"Permission denied " },
	{  14,	"EFAULT",	"Bad address " },
	{  15,	"ENOTBLK",	"Block device required " },
	{  16,	"EBUSY",	"Device or resource busy " },
	{  17,	"EEXIST",	"File exists " },
	{  18,	"EXDEV",	"Cross-device link " },
	{  19,	"ENODEV",	"No such device " },
	{  20,	"ENOTDIR",	"Not a directory " },
	{  21,	"EISDIR",	"Is a directory " },
	{  22,	"EINVAL",	"Invalid argument " },
	{  23,	"ENFILE",	"File table overflow " },
	{  24,	"EMFILE",	"Too many open files " },
	{  25,	"ENOTTY",	"Not a typewriter " },
	{  26,	"ETXTBSY",	"Text file busy " },
	{  27,	"EFBIG",	"File too large " },
	{  28,	"ENOSPC",	"No space left on device " },
	{  29,	"ESPIPE",	"Illegal seek " },
	{  30,	"EROFS",	"Read-only file system " },
	{  31,	"EMLINK",	"Too many links " },
	{  32,	"EPIPE",	"Broken pipe " },
	{  33,	"EDOM",	"Math argument out of domain of func " },
	{  34,	"ERANGE",	"Math result not representable " },
	{  52,	"EBADE",	"Invalid exchange " },
	{  53,	"EBADR",	"Invalid request descriptor " },
	{  54,	"EXFULL",	"Exchange full " },
	{  55,	"ENOANO",	"No anode " },
	{  56,	"EBADRQC",	"Invalid request code " },
	{  57,	"EBADSLT",	"Invalid slot " },
	{  58,	"EDEADLOCK",	"File locking deadlock error " },
	{  59,	"EBFONT",	"Bad font file format " },
	{  60,	"ENOSTR",	"Device not a stream " },
	{  61,	"ENODATA",	"No data available " },
	{  62,	"ETIME",	"Timer expired " },
	{  63,	"ENOSR",	"Out of streams resources " },
	{  64,	"ENONET",	"Machine is not on the network " },
	{  65,	"ENOPKG",	"Package not installed " },
	{  66,	"EREMOTE",	"Object is remote " },
	{  67,	"ENOLINK",	"Link has been severed " },
	{  68,	"EADV",	"Advertise error " },
	{  69,	"ESRMNT",	"Srmount error " },
	{  70,	"ECOMM",	"Communication error on send " },
	{  71,	"EPROTO",	"Protocol error " },
	{  73,	"EDOTDOT",	"RFS specific error " },
	{  83,	"ELIBEXEC",	"Cannot exec a shared library directly " },
	{  84,	"EILSEQ",	"Illegal byte sequence " },
	{  88,	"ENOTSOCK",	"Socket operation on non-socket " },
	{  95,	"EOPNOTSUPP",	"Operation not supported on transport endpoint " },
	{  96,	"EPFNOSUPPORT",	"Protocol family not supported " },
	{  97,	"EAFNOSUPPORT",	"Address family not supported by protocol " },
	{  98,	"EADDRINUSE",	"Address already in use " },
	{  99,	"EADDRNOTAVAIL",	"Cannot assign requested address " },
	{ 100,	"ENETDOWN",	"Network is down " },
	{ 101,	"ENETUNREACH",	"Network is unreachable " },
	{ 102,	"ENETRESET",	"Network dropped connection because of reset " },
	{ 105,	"ENOBUFS",	"No buffer space available " },
	{ 106,	"EISCONN",	"Transport endpoint is already connected " },
	{ 107,	"ENOTCONN",	"Transport endpoint is not connected " },
	{ 108,	"ESHUTDOWN",	"Cannot send after transport endpoint shutdown " },
	{ 109,	"ETOOMANYREFS",	"Too many references: cannot splice " },
	{ 110,	"ETIMEDOUT",	"Connection timed out " },
	{ 112,	"EHOSTDOWN",	"Host is down " },
	{ 113,	"EHOSTUNREACH",	"No route to host " },
	{ 114,	"EALREADY",	"Operation already in progress " },
	{ 115,	"EINPROGRESS",	"Operation now in progress " },
	{ 117,	"EUCLEAN",	"Structure needs cleaning " },
	{ 118,	"ENOTNAM",	"Not a XENIX named type file " },
	{ 119,	"ENAVAIL",	"No XENIX semaphores available " },
	{ 120,	"EISNAM",	"Is a named type file " },
	{ 121,	"EREMOTEIO",	"Remote I/O error " },
	{ 122,	"EDQUOT",	"Quota exceeded " },
	{ 514,	"ERESTARTNOHAND",	"restart if no handler.. " },
	{ 515,	"ENOIOCTLCMD",	"No ioctl command " },
{0,0,0}};

char * sys_errname(e)
{	int i;
	for (i=0; sys_errtbl[i].name;i++)
		if (e == sys_errtbl[i].code)
			return sys_errtbl[i].name;
	return unknown;
}

char * sys_errmessage(e)
{	int i;
	for (i=0; sys_errtbl[i].message;i++)
		if (e == sys_errtbl[i].code)
			return sys_errtbl[i].message;
	return unknown;
}
