:i	static char str_dupssm_sccs_id[] = "%W% %G%";
#include "D_M.h"
#include "str.h"
#include "mem.h"

/*
* Duplicate a string structure.  This is a common routine  that  does  several
* related  tasks.  If dst isn't provided, we malloc it, so this routine may be
* used to create a string. The src string may be omitted, and we will make dst
* into a null string.  If src is provided, we malloc space for a copy, plus an
* extra null byte for debugging purposes.  (Perhaps  this  null  byte  can  be
* omitted  eventually.)  The  result  is  a  valid Str descriptor that is an
* allocated copy of the src (or null).
*
* The return value is the address of the dst string, null for failure.   Note
* that  the  dst  string will end up with dst->v allocated, regardless of the
* origin of src->v.  There is an obscure memory  leak  here:   If  the  first
* GetChunk()  succeeds  and  the  second  one fails, we will forget about the
* malloc'd dst structure.  Correcting this may not be worthwhile, because the
* program will probably die shortly anyway.
*/
Str * str_dupssm(dst,src,msg)
	Str *dst;		/* Output string */
	Str *src;		/* Input string */
	char*msg;		/* For error messages */
{	int  m, n;
:f	Fenter("str_dupssm");
:2	if (!msg) msg = unknown;
	if (!dst) {		/* If there's no dst string, alloc one */
		if (!(dst = (Str*)GetChunk(sizeof(Str),msg)))
			Fail;		/* Note that GetChunk() zeroes the data */
:6		V8M "dst: l=%d m=%d v=%06X",dst->l,dst->m,dst->v V;
	}
	if (src && (n=src->l) && src->v) {	/* Is src nonnull? */
		m = MEMUNIT(n+StrPadLen);			/* Space to grab */
		if (Igt(m,dst->m)) {			/* Need to expand? */
:6			V8M "Alloc v=%08X m=%d l=%d",dst->v,dst->m,dst->l V;
			if (dst->m && dst->v)
				IRelChunk(dst->v,msg);	/* Get rid of old value */
			if (!(dst->v = (CP)GetChunk(m,msg))) {
				dst = 0;
				Fail;
			}
			dst->p = dst->v;
:6			V8M "Got %d bytes  for %s.",m,msg V;
			dst->m = m;
		}
		Bcopy(src->v,dst->v,n);	/* Copy the data */
		dst->l = n;
:6		V8M "dst: l=%d m=%d v=%06X",dst->l,dst->m,dst->v V;
	} else {		/* The src string is null */
:6		V8M m_null V;
		dst->l = 0;
	}
:2	if (Vlvl>2 && ChkStrM(dst,msg))
:2		V2M str_badstmsg V;
:1	if (dst->v)
:1		dst->v[dst->l] = 0;	/* Null terminator */
:5	V8M "dst: l=%d m=%d v=%06X=\"%s\"",
:5		dst->l,dst->m,dst->v,NulC(dst->v) V;
fail:
:f	Fexit;
	return dst;
}
